// BedData.H
// declarartion of BedData class
#ifndef BEDDATA_H
#define BEDDATA_H
#include <time.h>

#ifndef MAIN_H
  #include "main.h"
#endif
struct ParamNode {
  byte MFC,
       Val,	// 0:valid, 2:questionable,3:useless
       MCC,
       Type;
  int  Value1,
       Value2,
       Value3;
  boolean Display;
  char DisplayValue[10];
  char DisplayTime[15];
  ParamNode *Next;
};

class BedData {
  private:
    int BedNum,
        NumPSDParams,
        NumPVParams,
        LastNumPVParams,
        TempVal,
        FileWrites,
        StartFlag;
    boolean NPChanged;

    ParamNode *ThisP,*FirstP,*LastP;
  public:
    BedData(int=0);
    void SetBedNum(int);
    void UpdateData(byte*,int);
    void FormatForDisplay(void);
    void DisplayData(void);
    void WriteToFile(void);
    void SetTextColor(byte);
    void WriteHeader(char*, char*, char*);
    void WriteParamList(void);
    void WriteNewParamList(int);
    void WriteParamsToFile(void);
    int CheckStartFlag(void);
    void SetStartFlag(void);
    void ClearStartFlag(void);
    int CheckNPChanged(void);
    int GetNumPVParams(void);
};


#endif

