// readmsg.cpp

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include "readmsg.h"

#ifndef GENERAL_H
  #include "general.h"
#endif

#ifndef DATAMSG_H
  #include "datamsg.h"
#endif

#ifndef SRCTYPES_H
  #include "srctypes.h"
#endif

#ifndef MFC_H
  #include "mfc.h"
#endif

extern int TimedCplRead(byte[],int); // defined in CplDrvFn.CPP
extern "C" void CplWrite(byte*, unsigned);
extern byte DiscLSReq[];		// defined in SRCREQ.H


int ReadMsg(BedData *ThisBed)
{

  byte Buffer[200];
  byte *DataPtr;
  ElementHeader *ElHead;
  int MsgsRcvd = 0;
  int TempVal = 0;
  boolean LookForTemp = True;			// from PSD message

  // clear the keyb buffer

  while (kbhit()) getch();

  textcolor(WHITE);
  _setcursortype(_NOCURSOR);

  // try to read a data message

  do {

    if (!TimedCplRead(Buffer,2)) return 0;

    switch (Buffer[0]) {

      case  DATA_MSG :  MsgsRcvd++;

      			// read the length from the header
                        if (!TimedCplRead(Buffer,1)) return 0;

    			while (Buffer[0] > 6) {

    			  // read the rest of the header

    			  if (!TimedCplRead(&Buffer[2],2)) return 0;

    			  ElHead = (ElementHeader*)Buffer;

                          // check for a PV message/source is OK

                          switch (Buffer[3]) {

                            case 0x02 : 	// PVD
                              if (!TimedCplRead(&Buffer[6],(ElHead->Length/2)-3))
                              return 0;

                              if (MsgsRcvd % 4 == 0) {
                                ThisBed->UpdateData(&Buffer[6],TempVal);
                                ThisBed->FormatForDisplay();
                                ThisBed->DisplayData();
                              }
                              if ((MsgsRcvd % 60)-58 == 0) {
                                ThisBed->UpdateData(&Buffer[6],TempVal);
                                // Write to File
                                if (ThisBed->CheckStartFlag() == 0) {
                                   ThisBed->WriteParamList();
                                   ThisBed->SetStartFlag();
                                }
                                else if (ThisBed->CheckNPChanged())
                                   ThisBed->WriteNewParamList(ThisBed->GetNumPVParams());
                                else
                                  ThisBed->WriteParamsToFile();
                              }

                              break;

                            case 0x03 :		// PSD
                              if (!TimedCplRead(&Buffer[6],(ElHead->Length/2)-3))
                              return 0;
                              if (LookForTemp) {
                              	TempVal = GetTemp(&Buffer[6]);
                                if (TempVal) LookForTemp = False;
                              }
			      break;

                            default :
                              // cprintf("Not a PV/PSD message, source in "
			      // "self-test or not a monitor\n\r");
                            return 2;

                          }  // switch

                          // Display data every 4th message


    			  // read the length of the next element

    			  if (!TimedCplRead(Buffer,1)) return 0;

    			}

  			// all elements and messages read

  			break;

      case DISC_RESP :	// check that Disconnect was successful
      			if ((Buffer[2] & 0xF0) == 0x10) return 1;
                        else return 3;


      default :		// another message type, unable to handle, so exit
                        return 4;
    } // switch

    if (kbhit()) {
      getch();
      DiscLSReq[1] = 0x01;
      CplWrite(DiscLSReq,2);
    }
    LookForTemp = True;
  } while (!kbhit());
  getch();

  return 1;  // success
}


// Get Temperature Data from PSD
// GetTemp returns the temp as an int, 0 if no temp data
int GetTemp(byte *DPtr)
{
  PSData *PSD;
  PSD = (PSData*)DPtr;
  long TempVal=0;
  char TempStr[4];

  if ( (PSD->Text[0] == 'T')  && (  (PSD->Text[1] == '1')
                                 || (PSD->Text[1] == '2')
				 			) ) {
    sprintf(TempStr,"%c%c%c",PSD->Text[3],PSD->Text[4],PSD->Text[6]);
    TempVal = strtol(TempStr,NULL,0);
    return (int)TempVal;
  }
  else if ( (PSD->Text[0] == 'T') && (PSD->Text[1] == 'b') ) {
    sprintf(TempStr,"%c%c%c",PSD->Text[7],PSD->Text[8],PSD->Text[10]);
    TempVal = strtol(TempStr,NULL,0);
    // cprintf("Tempval = %d\n\r",TempVal);
    return (int)TempVal;
  }
  else return 0;
}


