// Default Logical Source Requests

#ifndef SRCREQ_H
#define SRCREQ_H

#ifndef GENERAL_H
  #include "general.h"
#endif

#ifndef SRCTYPES_H
  #include "srctypes.h"
#endif

// --------------------------------------
// default connect logical source request
// --------------------------------------

ConLSReq DefConLSReq = {	// default connect logical
  0x00,				// source request
  0x00,         		// LSN=0
  0x00,				// Mode=POLL
  0x00,				// IAF=0(enable),Const auto/sched auto
  0x00,				// Con type (must be 0)
  0x00,				// no beds selected
  0x00,
  0x00,
  0x01,				// include monitors but not computers
  0x00,				// no data classes
  0x00,
  0x00,				// include all MFC's
  0x00,				// include all PSLO's
  0x01				// wave list position =1
};


SuspLSReq DefSuspLSReq = {		// default suspend LS request
			SUSP_REQ_ID,
                        0x00,		// LSN
                        0x00,
                        0x00 };

ActLSReq DefActLSReq = {		// default activate LS request
			ACT_REQ_ID,
                        0x00,		// LSN
                        0x00,
                        0x00 };


// Disconnect Logical Source Request

byte DiscLSReq[] = {    0x05,		// request ID
                        0x00,		// LSN
                        0x00,
                        0x00 };

// Poll Logical Source Request

byte PollLSReq[] = {0x03,		// ID
		    0x00,		// LSN
                    0x00,
                    0x00 };



// Schedule Logical Source Request

byte SchdLSReq[] = {
			0x04,
                        0x01,		// LSN
                        0x00,		// Mode: 0=poll,1-FE=schd auto,
                        		// 	 FF=auto
			0x40 };		// bit7=Act/Susp control flag
                        		// bits 5-0=sched-period

// Logical source directory status

byte DirsLSReq[] = {	0x07,
			0x00,           // bits 5-4 LSN:
					  // 0=one LSN only
                                          // bits 3-0 LSN identifier
			0x00,
                        0x00 };

#endif


